#ifndef MAIN_H
#define MAIN_H

//#include <stdio.h>

#include "p24hj128gp502.h"

//#include  
//sub-headers



//#include<i2c.h>

typedef struct
{
	double lat;		///<latitude
	char NSi;		///<N=north or S=south
	double lon;		///<longitude
	char WEi;		///<W=west or E=east
	double date;		///< date ddmmyy
	double UTC;		///< UTC time (hhmmss.msc)
	char nav_w; 		///< A=data valid or V=data not valid
	double pos_fix;		///< 0-Fix not available or invalid;	1-GPS SPS Mode, fix valid;	2-Differential GPS, SPS Mode, fix valid; 3-5 - Not supported
	char have_fix;
	double speed;		///<Speed over ground, Knots
	double n_sat;		///<Satellites Used, range 0 to 12
	int sat1;		///<Satellites used
	int sat2;
	int sat3;
	int sat4;
	int sat5;
	int sat6;
	int sat7;
	int sat8;
	int sat9;
	int sat10;
	int sat11;
	int sat12;
	double PDOP;	///<Position Dilution of Precision
	double HDOP;	///<Horizontal Dilution of Precision
	double VDOP;	///<Vertical Dilution of Precision
	double alt;
	double softver;
	double bat_left;
	double bat_hour;
	int USB;
	double dim;	///< 1 - Fix not available; 2 - 2D (<3 SVs used); 3 - 3D (>3 SVs used)
	double mode;	///< A - 2D Automaticallowed to switch 2D/3D
}data_struct;

typedef struct
{
	int THR; ///<thrusters operation load
	double lat;		///<latitude
	double lon;		///<longitude
	double alt;		///<altitude
	double rol;		///<roll
	double pit;		///<pitch
	double yaw;		///<yaw
	double vel;		///<speed over ground
	int SO1;		///< sonars data
	int SO2;		///< sonars data
	int SO3;		///< sonars data
	int AC1;		///< accelerometer data
	int AC2;		///< accelerometer data
	int AC3;		///< accelerometer data
	int GY1;		///< gyroscope data
	int GY2;		///< gyroscope data
	int GY3; 		///< gyroscope data
	int HB1;		///< HBridge load
	int HB2;		///< HBridge load
	int HB3;		///< HBridge load
	int SE1;		///< Servo rotation
	int SE2;		///< Servo rotation
	int SE3;		///< Servo rotation
	int LED;		///< LED percentage
	int PWM;		///< PWMaux percentage
}stat_struct;

#ifdef MAIN_C
#	define EXTERN
#else
#	define EXTERN extern
#endif

EXTERN unsigned int i;
EXTERN int str_pntr; ///srting pointer for increment the message
EXTERN char RXstr[100]; /// buffer to store the receive string
EXTERN char RXstr_test[100];
EXTERN int RXstr_F;
EXTERN char TXstr[100];
EXTERN int ADCskip;
EXTERN unsigned int ADC_Mag1; ///first sample on pin0
EXTERN int ADC_Mag1_F;
EXTERN int ADC_Mag2; ///first sample on pin1
EXTERN int ADC_Mag2_F;
EXTERN int ADC_Dist; ///last sample on ADC channel
EXTERN int ADC_Dist_F; ///new sample take flag
EXTERN int ADC_Dist2; ///last sample on ADC channel
EXTERN int ADC_Dist2_F; ///new sample take flag
EXTERN data_struct *gps;
EXTERN stat_struct *stat;
EXTERN int F_AC1, F_AC2, F_AC3, F_LAT; ///< flags to signal new values




#endif
